--- pbx_ael.c.orig	2005-10-04 08:27:42.000000000 -0400
+++ pbx_ael.c	2005-10-04 09:09:00.000000000 -0400
@@ -484,6 +484,26 @@
 	return 0;
 }
 
+static char *argument_end(char *str)
+{
+	int level=0;
+	while(*++str) {
+		switch(*str) {
+		case '(':
+			level++;
+			break;
+		case ')':
+			if(level)
+				level--;
+			else
+				return str;
+			break;
+		default:
+			break;
+		}
+	}
+	return NULL;
+}
 static int build_step(const char *what, const char *name, const char *filename, int lineno, struct ast_context *con, char *exten, int *pos, char *data, struct fillin **fillout, char **label);
 static int __build_step(const char *what, const char *name, const char *filename, int lineno, struct ast_context *con, char *exten, int *pos, char *data, struct fillin **fillout, char **label)
 {
@@ -512,7 +532,7 @@
 		/* Switch */
 		args = data + strlen("switch");
 		while ((*args < 33) && (*args != '(')) args++;
-		if ((*args == '(') && (c = strchr(args, ')'))) {
+		if ((*args == '(') && (c = argument_end(args))) {
 			args++;
 			*c = '\0';
 			c++;
@@ -597,7 +617,7 @@
 		/* If... */
 		args = data + strlen("if");
 		while ((*args < 33) && (*args != '(')) args++;
-		if ((*args == '(') && (c = strchr(args, ')'))) {
+		if ((*args == '(') && (c = argument_end(args))) {
 			int ifblock;
 			int ifstart;
 			int elsestart;
@@ -659,7 +679,7 @@
 		fillin = NULL;
 		args = data + strlen("while");
 		while ((*args < 33) && (*args != '(')) args++;
-		if ((*args == '(') && (c = strchr(args, ')'))) {
+		if ((*args == '(') && (c = argument_end(args))) {
 			int whileblock;
 			int whilestart;
 			int whileend;
@@ -747,7 +767,7 @@
 		fillin = NULL;
 		args = data + strlen("for");
 		while ((*args < 33) && (*args != '(')) args++;
-		if ((*args == '(') && (c = strchr(args, ')'))) {
+		if ((*args == '(') && (c = argument_end(args))) {
 			int forblock;
 			int forprep;
 			int forstart;
